<template>
  <div>
    <detailsview
      v-bind.sync='leave'
      v-bind:remark.sync='conversation.remark'
      v-bind:firstname='employee.firstname'
      v-bind:lastname='employee.lastname'
      v-bind:employeecode='employee.employeecode'
      v-bind:mobilenumber='employee.mobilenumber'
      v-bind:department='employee.department'
      v-bind:show='show'
      v-on:takeAction='takeAction'
      v-on:cancel='cancel'
      v-on:close='close'
      v-on:submit='submit'
      v-bind:loading='loading'
    />
  </div>
</template>

<script>
import detailsview from '@/components/Details.vue';
// import Logger from '@/logger/index';
import Leave from '@/models/ApplyLeave';
import Employee from '@/models/Employee';
import Conversation from '@/models/Conversation';
// import ConversationList from '@/models/ConversationList';

export default {
  components: {
    detailsview,
  },
  data() {
    return {
      show: false,
      loading: false,
      leave: new Leave(),
      employee: new Employee(),
      conversation: new Conversation(),
    };
  },
  props: {
    id: {
      type: String,
      required: true,
    },
    uid: {
      type: String,
      required: true,
    },
  },
  mounted() {
    this.leave.uid = this.uid;
    this.leave.id = this.id;
    this.leave.fetch();
    this.employee.uid = this.uid;
    this.employee.id = this.uid;
    this.employee.fetch();
    this.conversation.uid = this.uid;
    this.conversation.id = this.id;
    this.conversation.fetch();
  },
  methods: {
    takeAction() {
      this.show = true;
    },
    close() {
      this.show = false;
    },
    cancel() {
      this.$router.replace({ name: 'Home' });
    },
    submit() {
      this.loading = true;
      this.conversation.create().then(() => {
        console.log('Done creating conversation collection', this.conversation.id);
      });
      this.leave.updateStatus().then(() => {
        this.$store.dispatch('setSnackbarText', 'Updating Department list');
        this.$store.dispatch('setShowSnackbar', true);
        this.$router.replace({ name: 'Home' });
      });
    },
  },
};
</script>
